#!/bin/sh

ABORTER_PATH="/bin/rm"
WEB_DIR="/usr/local/www/IDrive"
PKG_PATH="$APKG_PKG_DIR"
SYSTEM_SU="/bin/busybox"

cd "$PKG_PATH"

case "$1" in
    start)
		#replacing our su file with system su if present
		if [ -e "$SYSTEM_SU" ]; then
			"$ABORTER_PATH" "$WEB_DIR"/.config/su
			/bin/cp -rfp "$SYSTEM_SU" "$WEB_DIR"/.config/su
			/bin/chmod 04755 "$WEB_DIR"/.config/su
		fi
		
		#/usr/bin/perl $WEB_DIR/.scripts/pathchanges.pl Asustor
		/usr/builtin/bin/php -d open_basedir=NULL $WEB_DIR/.scripts/pathchanges.php Asustor
		exec /usr/builtin/bin/php "$WEB_DIR/.config/IDrive_cron.php" &
        ;;
    stop)
		echo "Stoping IDrive Backup:"
		
		;;
		
    restart)
        echo "Restarting IDrive Backup:"
		#/bin/cp -rfp "$SYSTEM_SU" "$WEB_DIR"/.config/su
		#/bin/chmod 04755 "$WEB_DIR"/.config/su
        ;;
    *)
        echo "usage: $0 {start|stop|restart}"
        exit 2
        ;;
esac
exit 0