<?php
require_once 'path.php';
if(!isset($_SESSION['validUser']) || $_SESSION['validUser'] !== true)
{
	header("Location:../index.php");
	exit();
}
$pageSubmitted = false;

$partialData = array();
$fullData = array();

unset($_SESSION['partialEntry']); 
unset($_SESSION['fullEntry']);

if($_SESSION['validUser'] === true)
{
	if($_POST)
	{   	
		if($userName!='' && $_POST["backupLocation"] != ""){
			if(file_exists($excludePartialFilePath))
				unlink($excludePartialFilePath);

			if(file_exists($excludeFullFile))
				unlink($excludeFullFile);
				
			if($_POST['hiddenStatus']==2){
				file_put_contents($excludePartialFilePath, "\/.\n");
				@chmod($excludePartialFilePath, $permissionVal);
				$_SESSION['showHidden']="Hide";
			}
			else if($_POST['hiddenStatus']==1)
				$_SESSION['showHidden']="Show";
			
			if(isset($_POST['selectedPartial']) && ($_POST['selectedPartial'] != "")) {
				$i=0;
				foreach($_POST['selectedPartial'] as $selectedPartial)
				{
					$selectedPartial = phpRealEscapeString($selectedPartial);
					$_SESSION['partialEntry'][$i] = $selectedPartial;	
					file_put_contents($excludePartialFilePath, $selectedPartial."\n", FILE_APPEND);
					$i++;
				}
				@chmod($excludePartialFilePath, $permissionVal);
			}

			if((int)$_POST['displayRoot'] == 1)
				file_put_contents(Scheduler::$user_dir . DISPLAY_ROOT_FILENAME, 1);
			else
				file_put_contents(Scheduler::$user_dir . DISPLAY_ROOT_FILENAME, 0);

			@chmod(Scheduler::$user_dir . DISPLAY_ROOT_FILENAME,$permissionVal);
		
			if($_POST['selectedFull'] != "") {
				$selectedFull = $_POST['selectedFull'];
				$imgType      = $_POST['imgType'];
				
				# Checking whether first entry of POST is working directory
				$servicePath = getOriginalServicePath();
				if(checkServicePath($servicePath, phpRealEscapeString(trim($selectedFull[0])))) {
					$_SESSION['fullEntry'][] = $servicePath;
					$_SESSION['fullEntry'][] = 'folder';
					file_put_contents($excludeFullFile, $servicePath . "\n" . "folder\n");
					
					# if first entry is servie directory just shift 1 element from type and path array
					array_shift($selectedFull);
					array_shift($imgType);
				}
				
				foreach($selectedFull as $index => $selectedFile) { 
					$selectedFile = phpRealEscapeString($selectedFile);
					if(substr($selectedFile, -1) == "/")
						$entry = substr($selectedFile, 0, -1); 
					else
						$entry = $selectedFile;
				
					$entry 				= trim($entry);
					$imgType[$index]	= trim($imgType[$index]);
					
					# Make sure it doesn't cause any duplicate entries
					if(isset($_SESSION['fullEntry']) && in_array($entry, $_SESSION['fullEntry']))
						continue;

					$_SESSION['fullEntry'][]  = $entry;
					$_SESSION['fullEntry'][]  = $imgType[$index];
					
					file_put_contents($excludeFullFile, ($entry ."\n" . $imgType[$index] . "\n"), FILE_APPEND);
				}
				@chmod($excludeFullFile, $permissionVal);
			}
		
			/* Update backup location to mpc.txt */
			update_mpc($_POST["backupLocation"]);

			/* Proxy Settings - Start */
			$accountSettingsFilePath = "$webDir/".SERVICE."/".USER_PROFILE."/$userName/ACCOUNT_SETTINGS_FILE";
			$lines = file($accountSettingsFilePath);
			foreach ($lines as $line){ 
				if (strpos($line, 'PROXY')  !== false) 
					$proxyString = $line;
			}	

			if($_POST["proxy_option"]!='No-Proxy' && $_POST["ipAddress"] != "")
			{
				if(($file = fopen($accountSettingsFilePath, "a+")) != FALSE)
				{ 	
					if($proxyString)
					{ 
						$ASFPList = array();
						$index = 0;		    
		 
						$ASFPList = shell_exec("grep -v \"PROXY\" $accountSettingsFilePath");
						ftruncate($file, 0);

						while($ASFPList[$index] != "")
						{ 
						  fputs($file, $ASFPList[$index]);
						  $index++;
						}    
					}
					
					fwrite($file, "PROXY = ".urlencode($_POST["userName"]).":".urlencode(base64_decode($_POST["password"]))."@".$_POST["ipAddress"].":".$_POST["port"]."\n");
					fclose($file);
					@chmod($accountSettingsFilePath, $permissionVal);
					
					$_SESSION['proxy_option'] = $_POST["proxy_option"]=='autodetect'?'autodetect':'Manual';
					$_SESSION['ipAddress']    = $_POST["ipAddress"];
					$_SESSION['port']         = $_POST["port"];
					$_SESSION['proxyUserName']= $_POST["userName"];
					$_SESSION['proxyPassword']= $_POST["password"];				
				}
				else
				{ 				      	    
					print "File $file could not be opened successfully";	  		
					exit;  
				}
			} else {
				if(isset($proxyString) && $proxyString)
				{ 
					if(($file = fopen($accountSettingsFilePath, "a+")) != FALSE)
					{
						$ASFPList = array();
						$index = 0;		    

						$ASFPList = shell_exec("grep -v \"PROXY\" $accountSettingsFilePath");
						ftruncate($file, 0);
						if($ASFPList){
							while($ASFPList[$index] != "")
							{ 
							  fputs($file, $ASFPList[$index]);
							  $index++;
							}    
						}
					}	
				}
				unsetProxySessions();
			}
				 /* For Bandwidth throttle - Start*/
					$bandwidthFilePath = "$webDir/".SERVICE."/".USER_PROFILE."/$userName/".BW_FILE;	
					$bandWidth = $_POST["bandWidth"];
					if($bandWidth == 100 || $bandWidth == "")
					{
						if(file_exists($bandwidthFilePath)){ unlink($bandwidthFilePath); }
					}
					else
					{
						file_put_contents($bandwidthFilePath, $bandWidth);
						@chmod($bandwidthFilePath, $permissionVal);
					}    
				 /* For Bandwidth throttle - End*/
			/* Proxy Settings - End */

			/* Relative/Mirror Path Settings - Start */ 
		   $relativeFile = "$webDir/".SERVICE."/".USER_PROFILE."/$userName/".RELATIVE_FILE;
			if($_POST["pathType"])
			{
				$pathtypeToset = "--".$_POST["pathType"];
				file_put_contents($relativeFile, $pathtypeToset);
				@chmod($relativeFile, $permissionVal);
			} else if(file_exists($relativeFile))
				unlink($relativeFile); 

			/* Relative/Mirror Path Settings - End */
			
			print PREFERENCES_SUCC;
			exit();
		} else {
			$_SESSION['proxy_option']=$_POST["proxy_option"];
			if($_POST["proxy_option"]=='Manual' || $_POST["proxy_option"]=='autodetect'){
				$_SESSION['ipAddress']=$_POST["ipAddress"];
				$_SESSION['port']=$_POST["port"];
				$_SESSION['proxyUserName']=$_POST["userName"];
				$_SESSION['proxyPassword']=$_POST["password"];
			} 
			else 
				unsetProxySessions();		
		}
	}
}

?>
