<?php 
ini_set('track_errors', 1);
error_reporting(0);
//error_reporting(E_ALL);
setDateTimeZone(); //Set server's time zone to PHP if it is different one

define('APPDIR','IDrive');
define('SERVICE','idriveIt');

define('ARCHIVE', "Archive");
define('ASSIGNMENTOP',"=");
define('BACKUP', "Backup");
define('BACKUP_CHILDPROCESSFILE', "Backup_Script_ChildProcess_IDrive.php");
define("BACKUPARRAY_LIMIT",50);					#60000
define('BACKUPSETFILE_RELATIVE', 'BackupsetFile_relative.txt');
define('BACKUPSETFILE_NORELATIVE', 'BackupsetFile_no-relative.txt');
define('BACKUPSETFILE_ONLYFILES', 'BackupsetFile_onlyFiles.txt');
define("CHILD_PROCESS_STARTED",1);
define("CHILD_PROCESS_COMPLETED",2);
define('CONFIG_FILE','configure.txt');
define('CLEANUP',"Cleanup");
define('CONFIG','.config');
define('CANCEL_PATH','cancel.txt');
define("CREATE_THOUSANDS_FILES_SET_SUCCESS","16");
define("CHECKDIRECTORIESFILE","checkDirectories.php");
define('DELETE', "Delete");
define('DEFAULT_RESTORE_LOCATION','RESTORE_DATA');
define('EVS_TEMP', "evs_temp");
define('EXEC_ERRORFILE', "exec_errorfile");
define('ERRORFILE', "error.txt");
define('ERROR_DIR', "ERROR");
define('ERRORREDIRECTION',"2>&1");
define('EXCLUDE_FULLPATH', 'ExcludeFullPath.txt');
define('EXCLUDE_PARTIALPATH', 'ExcludeListPartial.txt');
define('EXTENDED_LIST','ExtendedList.txt');
define("FILE_MAX_COUNT","1000");
define("FILE_COUNT_PROCESS_STARTED","1");
define("FILE_COUNT_PROCESS_COMPLETED","2");
define("FOLDER","folder");
define("FAILEDFILES","FailedFiles_ERROR.txt");
define("FORKPROCESSFILE","forkProcess.php");
define('GETSERVERADDRESS',"getServerAddress");
define('GETSCHEDULERDETAILSFILE',"getSchedulerDetails.php");
define('INFOFILE', "tempfiles/info_file");
define('IDEVSUTIL_ARG',"--utf8-cmd");
define('IBFOLDER','ibfolder');
define('IBFILE','ibfile');
define('IDRIVE_LOCAL_DB','IDriveLocal.db');
define('JOBTERMINATIONFILE', "Job_Termination_Script.php");
define('LOG_FILE_SIZE_LIMIT','1 * 1024 * 1024');
define('LOG_FILE_MAX_COUNT','5');
define('LOG_FILE','traceLog.txt');
define('LOCALSEARCH',"LocalSearch");
define('LOGPIDFILE',"logpid.txt");
define('LOCALBACKUP',"LocalBackup");
define('LOCALRESTORE',"LocalRestore");
define("LOCAL_FILE_FOLDER_SELECT_FAILURE","18");
define("LOCAL_SELECT_SUCCESS","19");
define('LINEFEED',"\n");
define("LIMIT",	50*1024); 
define('LDBNEW','LDBNEW');
define('MAX_LOG_FILE_COUNT',5);
define('MAX_LOG_FILE_SIZE',1);
define("MAX_RETRY","5");
define('MPC_FILE','mpc.txt');
define('MANUAL','Manual');
define('MANUALTASK','+ManualTask');
define("NO_SUCH_FILE_OR_DIRECTORY",  "No such file or directory");
define('NOSCANERRORFILE', "0");
define('NORELATIVE', "--no-relative");
define('OUTPUTFILE', "output.txt");
define('OPERATIONSFILE', "operations.php");
define('PIDFILE', "pid.txt");
define('PROPERTIES',"properties");
define('PATHSEPARATOR',"/");
define('PERMISSIONVAL',0777);
define('PARTIAL_SYNC_FILE','PartialSyncFile.txt');
define('PHP_IGNORE_OPENBASEDIR', ' -d open_basedir=NULL ');
define('PROGRESS_PATH','progress.txt');
define('RESTORE',"Restore");
define('RESTORE_CHILDPROCESSFILE',"Restore_Script_ChildProcess.php");
define('RELATIVE', "--relative");
define('REMOTESEARCH',"RemoteSearch");
define('RETRY_INFOFILE', "tempfiles/retry_info_file");
define("RESTORE_SUCCESS","11");
define("REMOTE_SEARCH_FAIL","12");
define("REMOTE_SEARCH_CMD_ERROR","13");
define("REMOTE_SEARCH_OUTPUT_PARSE_FAIL","14");
define("REMOTE_SEARCH_SUCCESS","15");
define("REMOTE_SEARCH_THOUSANDS_FILES_SET_ERROR","17");
define('RESTORESETFILE_RELATIVE', 'RestoresetFile_relative.txt');
define('RESTORESETFILE_NORELATIVE', 'RestoresetFile_no-relative.txt');
define('RESTORESETFILE_ONLYFILES', 'RestoresetFile_onlyFiles.txt');
define('RELATIVE_FILEPATH', '.relative.txt');
define('STARTPIDFILE', "StartPid.txt");
define('SENDMAILFILE', "sendmail.php");
define('SCRIPTS', ".scripts");
define('SCANERRORFILE', "1");
define('STATUSFILE',"STATUS_FILE");
define('SERVERERROR',"unauthorized user");
define("SEARCH","search");
define("SPLIT_LIMIT_OUTPUT_PARSE","6");
define("SPLIT_LIMIT_INFO_LINE","3");
define("SEARCH_LIMIT",200);							#6000000
define("SEARCHLEVEL",1);
define("SEARCHALL",0);
define('SEARCH_FOR_RESTORE','1');
define('SERVER_ADDR_PATH','.serverAddr.txt');
define('SCHEDULED','Scheduled');
define('TOTAL_SIZE_PATH','totalsize.txt');
define('TEMP_FILES', "tempfiles");
define('TEMP_OPERATION_FILE', 'temp_operationsfile.txt');
define('TRASHSEARCH',"TrashSearch");
define('UTFFILE',"utf8.txt");
define('USER_PROFILE','user_profile');
define('WHITESPACE'," ");
define('DEDUP_DETAIL_FILE','deDupDetail.txt');
define('DEDUP_RESTORE_DEVICE_FILE','dedupRestoreDeviceID.txt');
define('WAIT_FOR',0.5);

#Machine   
define('NETGEAR','netgear');    
define('QNAP','QNAP');                 
define('SYNOLOGY','synology');
define('TWOTIER','twotier');
define('ASUSTOR','Asustor');

##################################
#Operation Type                  #
##################################
$totalSize = "calculating";
$mode = 'release';
$taskType = MANUAL;
$failedfiles_index = 0;
$psPath = "";
$pidIdx = "";
$cronSeparator = "";
$failedFilesCount = 0;
$userCancelStr = "Operation could not be completed. Reason : Operation cancelled by User";
$logOutputFilePath = "";
$operationName = "";
$retrycount = 0;
$prevFailedCount = 0;
$separator = "";
$statusFileHash = array();
$trash = 0;
$headerMsg = "";
$status = "";
$backupLocation = "";
$flag;
$errStr = "";
$cancelFlag = false;
$jobrunningDir = `pwd`;
$jobrunningDir = trim($jobrunningDir, LINEFEED);
$errorFile = $jobrunningDir.PATHSEPARATOR.ERROR_DIR.PATHSEPARATOR.TEMP_FILES.PATHSEPARATOR.FAILEDFILES;

#Array containing the lines read from Account Settings File     
$linesAccountSettingsFile = array();

#Hash to hold the values of arguments to be passed to idevsutil binary
$hashEvsParameters = array( 
			"SERVERADDRESS" => "--getServerAddress",
			"USERNAME" => "--user",
			"PASSWORD" => "--password-file",                       
			"ENCTYPE" => "--enc-type",
			"PVTKEY" => "--pvt-key",                       
			"VALIDATE" => "--validate",
			"CONFIG" => "--config-account",
			"PROXY" => "--proxy",
			"UTF8CMD" => "--utf8-cmd",
			"ENCODE" => "--encode",
			"FROMFILE" => "--files-from",
			"TYPE" => "--type",
			"BWFILE" => "--bw-file",
			"PROPERTIES" => "--properties",
			"XMLOUTPUT" => "--xml-output",
			"GETQUOTA" => "--get-quota",
			"AUTHLIST" => "--auth-list",
			"SPEED" => "--trf-",
			"OUTPUT" => "--o",
			"ERROR" => "--e",
			"QUOTAFROMFILE" => "--quota-fromfile",
			"CREATEDIR" => "--create-dir",
			"SEARCH" => "--search",
			"ADDPROGRESS" => "--add-progress",
			"FILE" => "--file",
			"ENCOPT" => "--enc-opt",
			"PORTABLE" => "--portable",
			"PORTABLEDEST" => "--portable-dest",
			"MASKNAME" => "--mask-name",
			"NOVERSIONS" => "--no-versions",
			"DEVICE_ID"=>"--device-id"
);

$filesConsideredCount = "";
$totalFiles = 0;
$failedFiles = 0;
$summaryMsg = "";
$mailSummaryMsg = "";
$successFiles = 0;
$syncedFiles = 0;
$httpuser = `whoami`;
$httpuser = trim($httpuser);
$bacSync = 0;
$filecount = 0;
$machine = '';

#Get config information                  
if(!isset($_SESSION['machine']) || !isset($_SESSION['webDir']) || !isset($_SESSION['nasUser']) || !isset($_SESSION['cronCat'])) {
	$configFilehash = getVars();
}
$webDir 		= isset($configFilehash['webDir'])? $configFilehash['webDir'] : '';
$user    		= isset($configFilehash['nasUser'])? $configFilehash['nasUser'] : '';
$machine 		= isset($configFilehash['machine'])? $configFilehash['machine'] : '';
$cronCat		= isset($configFilehash['cronCat'])? $configFilehash['cronCat'] : '';
$webDir = trim($webDir);
$user = trim($user);
$machine = trim($machine);
$cronCat = trim($cronCat);

#get user name 
$username = "";
$username = getUserName();
$userDir = $webDir.PATHSEPARATOR.SERVICE.PATHSEPARATOR.USER_PROFILE.PATHSEPARATOR.$username;
$localBackupLocationFile = "$userDir".PATHSEPARATOR."localBackupLocation.txt";
$varLocalBackupManualTask  = "\/$username\/LocalBackup\/";  
$varLocalRestoreManualTask = "\/$username\/LocalRestore\/";
$isLocalBackup = 0;                                                                        
$isLocalRestore = 0;                                                                   
$jobDir = $jobrunningDir.PATHSEPARATOR;   
$dedupDetailFile = "$userDir".PATHSEPARATOR.DEDUP_DETAIL_FILE;
$dedupRestoreDeviceID	= "$userDir".PATHSEPARATOR.DEDUP_RESTORE_DEVICE_FILE;

if(TWOTIER == $machine){
	
	if(preg_match("/$varLocalBackupManualTask/", $jobDir)){                                                  
		$isLocalBackup = 1;                                                                 
	}
	if(preg_match("/$varLocalRestoreManualTask/", $jobDir)){                                                  
		$isLocalRestore = 1;                                                                 
	}
}
else{
	$isLocalBackup = 2;
	$isLocalRestore = 2;
}

$host = getNAShostname();

if(QNAP == $machine){
	$cronSeparator = " ";
    $pidIdx = 2;
    $separator = "/";
}
elseif(SYNOLOGY == $machine){
	$dsmVersion6 = false;
	$dsmVersionCmdOut = `cat /etc.defaults/VERSION`;
	$dsmVersionArr = preg_split('/\n/', $dsmVersionCmdOut);
	chop($dsmVersionArr[0], "\n");
	
	if(preg_match("/\"6\"$/", $dsmVersionArr[0])){
		$dsmVersion6 = true;
	}
	
	if($dsmVersion6){
		$psPath = "ps -elf";
		$pidIdx = 3;
	}
	else{
		$psPath = "ps -wwwww";
		$pidIdx = 0;
	}
	$cronSeparator = "\t";
    $separator = " ";
}
elseif(TWOTIER == $machine){
	$psPath = "ps -wwwww -ax";
	$pidIdx = 0;
	$cronSeparator = "\t";
    $separator = " ";
}
else if(ASUSTOR == $machine){
	$psPath = "ps -elf";
	$pidIdx = 0;
	$cronSeparator = " ";
    $separator = " ";
}
else {
	$psPath = "ps -elf";
	$pidIdx = 6;
	$cronSeparator = "\t";
    $separator = " ";
}
$phpPath = getPhpPath();
$deDup = false;
#idevsutil binary path
if(file_exists($dedupDetailFile)){
	$idevsutilBinaryPath = $webDir.PATHSEPARATOR.APPDIR.PATHSEPARATOR."idevsutil_IDrive_Dedup";
	$deDup = true;
}
else 
	$idevsutilBinaryPath = $webDir.PATHSEPARATOR.APPDIR.PATHSEPARATOR."idevsutil_IDrive";

//-------------------------------------- A ------------------------------------------------
#********************************************************************************************************
# Subroutine Name         : addtionalErrorInfo.
# Objective               : Logs error info into temporay error text file which is displayed in Log page.
# Added By                : Basavaraj Bennur [11/25/2016]
# Modified By			  : Senthil Pandian
#********************************************************************************************************/
function addtionalErrorInfo($error,$tmpErrorPath='')
{	
	if($tmpErrorPath!=''){
		$tmpErrorPath = ERROR_DIR."/".$tmpErrorPath;
		file_put_contents($tmpErrorPath,$error);
		@chmod($tmpErrorPath, PERMISSIONVAL);
	}
}
#********************************************************************************************************
# Subroutine Name         : appendErrorFileContents.
# Objective               : 
# Added By                : Pooja H
# Added On				  : 
# Modified By			  : 
# Modified On			  :
#********************************************************************************************************/
function appendErrorFileContents()
{
	$mail_content = "";
	$error_dir = ERROR_DIR.PATHSEPARATOR.TEMP_FILES.PATHSEPARATOR;
	$files_list = scandir($error_dir);
	$fileopen = 0;
	
	foreach ($files_list as $file){
		if($file == "." || $file == ".."){
			continue;
		}
		$file = $error_dir.$file;
		$file_content = '';
		rtrim($file);
		if(file_exists($file) and customFileSize($file) > 0){
			if($fileopen == 0){
				$mail_content.=LINEFEED."_______________________________________________________________________________________";
				$mail_content.=LINEFEED."|Error Report|".LINEFEED;
				$mail_content.="_______________________________________________________________________________________".LINEFEED;
				$fileopen = 1;
			}
			
			$file_content = file_get_contents($file);		
			if($file_content)
				$mail_content.= $file_content;
		}
	}		
	return $mail_content;
}

#******************************************************************************************************************
# Subroutine Name         : autoUpdateBackupset.
# Objective               : This subroutine is to udpate the default backup set file.
# Added By                : Deepak Chaurasia.
#******************************************************************************************************************/
function autoUpdateBackupset()
{
	GLOBAL $machine, $phpPath, $webDir, $userDir;
	
	if(TWOTIER == $machine){
		$cmd = $phpPath.$webDir.PATHSEPARATOR.APPDIR.PATHSEPARATOR.CONFIG.PATHSEPARATOR.CHECKDIRECTORIESFILE.WHITESPACE.$userDir;
		`$cmd`;
	}	
}


//-------------------------------------- B ------------------------------------------------



//-------------------------------------- C ------------------------------------------------
#********************************************************************************************************
# Subroutine Name         : setTimeZone.
# Objective               : Set server's time zone to PHP if it is different one
# Added By                : Senthil Pandian [03/16/2017]
# Modified By			  : 
#********************************************************************************************************/
function setDateTimeZone(){
	$timeZoneArray = array('GMT-11:00'=> 'Pacific/Midway', 'GMT-10:00'=> 'Pacific/Honolulu', 'GMT-09:00'=> 'America/Anchorage', 'GMT-08:00'=> 'America/Los_Angeles', 'GMT-07:00'=> 'America/Denver', 'GMT-06:00'=> 'America/Chicago', 'GMT-05:00'=> 'America/New_York', 'GMT-04:30'=> 'America/Caracas', 'GMT-04:00'=> 'Canada/Atlantic', 'GMT-03:30'=> 'America/St_Johns', 'GMT-03:00'=> 'America/Sao_Paulo', 'GMT-02:00'=> 'America/Noronha', 'GMT-01:00'=> 'Atlantic/Azores', 'GMT+00:00'=> 'Europe/London', 'GMT+01:00'=> 'Europe/Rome', 'GMT+02:00'=> 'Europe/Athens', 'GMT+03:00'=> 'Asia/Kuwait', 'GMT+03:30'=> 'Asia/Tehran', 'GMT+04:00'=> 'Asia/Muscat', 'GMT+04:30'=> 'Asia/Kabul', 'GMT+05:00'=> 'Asia/Karachi', 'GMT+05:30'=> 'Asia/Calcutta', 'GMT+05:45'=> 'Asia/Katmandu', 'GMT+06:00'=> 'Asia/Dhaka', 'GMT+07:00'=> 'Asia/Bangkok', 'GMT+08:00'=> 'Asia/Hong_Kong', 'GMT+09:00'=> 'Asia/Tokyo', 'GMT+09:30'=> 'Australia/Adelaide', 'GMT+10:00'=> 'Australia/Brisbane', 'GMT+11:00'=> 'Asia/Vladivostok', 'GMT+12:00'=> 'Pacific/Auckland', 'GMT+13:00'=> 'Pacific/Tongatapu');

	$phpTimeZone    = date('T'); //Ex:IST
	$phpTimeZone	= trim($phpTimeZone);
	$serverTimeZone = shell_exec('date +%Z'); //Ex:UST
	$serverTimeZone = trim($serverTimeZone);
	if($phpTimeZone != $serverTimeZone){
		$serverTimeZone = shell_exec('date +%:z');//Ex:+05:30
		$serverTimeZone = trim($serverTimeZone);		
		$timeZone = "GMT$serverTimeZone";
		if($timeZone){
			$setTimeZone = $timeZoneArray[$timeZone];
			date_default_timezone_set($setTimeZone);
		} else if( ! ini_get('date.timezone') ){
			//To avoid "Warning: date(): It is not safe to rely on the system's timezone settings."
			date_default_timezone_set('GMT');
		}	
	}
}

#********************************************************************************************************
# Subroutine Name         : convertFileSize.
# Objective               : converts the file size of a file into human readable format.
# Added By                : Senthil Pandian
# Added On				  : 11/25/2016
# Modified By			  : 
# Modified On			  :
#********************************************************************************************************/
function convertFileSize($bytes)
{
	if(!is_numeric($bytes))
		return $bytes;
	
	$precision = 2;
	$kilobyte = 1024;
	$megabyte = $kilobyte * 1024;
	$gigabyte = $megabyte * 1024;
	$terabyte = $gigabyte * 1024;

	if ($bytes < $kilobyte) 
		return $bytes . ' B';
	elseif (($bytes >= $kilobyte) && ($bytes < $megabyte)) 
		return round($bytes / $kilobyte, $precision) . ' KB';
	elseif (($bytes >= $megabyte) && ($bytes < $gigabyte)) 
		return round($bytes / $megabyte, $precision) . ' MB';
	elseif (($bytes >= $gigabyte) && ($bytes < $terabyte)) 
		return round($bytes / $gigabyte, $precision) . ' GB';
	elseif ($bytes >= $terabyte) 
		return round($bytes / $terabyte, $precision) . ' TB';
}	
#****************************************************************************************************
# Subroutine Name         : copyTempErrorFile
# Objective               : This subroutine copies the contents of the temporary error file to the 
#							Error File.
# Added By                : 
# Modified By			  : Vijay Vinoth
#*****************************************************************************************************/
function copyTempErrorFile($job_error)
{
	// if error file is empty then return 
	if(!customFileSize(ERRORFILE))
		return;
	
	#read error file content 
	$tempErrorFileContents = file(ERRORFILE);
	
	$file = ERROR_DIR."/$job_error";
	
	#open the App error file and if failed to open then return	
	$ERRORFILE = fopen($file,"a");
	if (!$ERRORFILE){     
		traceLog("Unable to open file $file, Reason: ".customErrorMsg());
		return;
	}
	$tempErrorFileContentsCount = count($tempErrorFileContents);
	#write the content of error file in App error file
	for($index = 0; $index < $tempErrorFileContentsCount; $index++){
		$tempErrorFileContents[$index] = trim($tempErrorFileContents[$index]);
		if($tempErrorFileContents[$index] != ""){
			fwrite($ERRORFILE,$tempErrorFileContents[$index].LINEFEED);
		}
	}
	@chmod ($file,PERMISSIONVAL);
	fclose($ERRORFILE);
}


#****************************************************************************************************
# Subroutine Name         : createLogFiles.
# Objective               : This subroutine creates the Log Directory if not present. It also creates 
#							the Error Log and Output Log files.
# Added By             	  : Vijay Vinoth
#*****************************************************************************************************/
function createLogFiles($outputFileName)
{  
	GLOBAL $logOutputFilePath;
	
    $logDirectory = "LOGS";
  	if(!is_dir($logDirectory)){
		if(! mkdir($logDirectory)){
			$errMsg = "Unable to create directory $logDirectory, Reason:".customErrorMsg();
			traceLog($errMsg);
			unlink(PIDFILE);
			unlink(STARTPIDFILE);
			exit;
		}
		chmod($logDirectory,PERMISSIONVAL);
	}
	
	//$currentTime = trim(date("Y-m-d h:i:s A"));
	$currentTime = trim(shell_exec('date +"%Y-%m-%d %I:%M:%S %p"'));
	$logOutputFilePath = $logDirectory.PATHSEPARATOR.$currentTime.WHITESPACE.$outputFileName; 
	if(!is_dir(ERROR_DIR)){
		if(! mkdir(ERROR_DIR)){
			$errMsg = "Unable to create directory ".ERROR_DIR.", Reason:".customErrorMsg();
			exitError($errMsg);
			exit;
		}
		chmod(ERROR_DIR,PERMISSIONVAL);
		$errorFilePathInter = ERROR_DIR."/".TEMP_FILES;
		if(! mkdir($errorFilePathInter)){
			$errMsg = "Unable to create directory $errorFilePathInter, Reason:".customErrorMsg();
			exitError($errMsg);
			exit;
		}
		chmod($errorFilePathInter,PERMISSIONVAL);
	}
}

#****************************************************************************************************
# Subroutine Name         : checkIfSetEmpty.
# Objective               : Checks if the Backupset is empty or not
# Added By                : Pooja Havaldar
#*****************************************************************************************************/
function checkIfSetEmpty($fileSet)
{
	if(! customFileSize($fileSet)){
		traceLog("$fileSet is empty.");
		exit;
	}
}

#****************************************************************************************************
# Subroutine Name         : checkIfJobRunning.
# Objective               : This subroutine will check whether jobs are running in particular path
# Modified By             : Pooja Havaldar
#*****************************************************************************************************/
function checkIfJobRunning($ArchiveJobPath)
{
	$files_list = getDirList($ArchiveJobPath);
	if(count($files_list) == 0)
		return 0;
	foreach($files_list as $value)
	{
		$value = trim($value);
		if($value == "." or $value == "..")
			continue;
		
		if(isFileLocked($ArchiveJobPath.$value."/".PIDFILE))
			return 1;
	}
	return 0;
}

#****************************************************************************************************
# Subroutine Name         : checkIfDeleteJobRunning.
# Objective               : This subroutine will check whether Delete jobs are running in particular path
# Modified By             : Vijay Vinoth
#*****************************************************************************************************/
function checkIfDeleteJobRunning($DeleteJobPath)
{
	$item_pidpath = $DeleteJobPath."/pid.txt";
	if(! file_exists($item_pidpath))
		return 0;
	$deleteOpType = file_get_contents($item_pidpath);
	if($trim($deleteOpType) == "Delete"){
		if(isFileLocked($item_pidpath))
			return 1;
	}
	return 0;
}

#*******************************************************************************************************
# Subroutine Name         : checkErrorAndUpdateServerAddr.
# Objective               : Read error.txt file check for server error if found update server address.
# Added By                : Avinash Kumar.
#*******************************************************************************************************/
function checkErrorAndUpdateServerAddr()
{
	if(file_exists(ERRORFILE) and 0 < customFileSize(ERRORFILE)){
		$errorContent = file_get_contents(ERRORFILE);
		if(preg_match("/".SERVERERROR."/", $errorContent)){
			updateServerAddr();
			return 1;
		}
	}
	return 0;
}

#**************************************************************************************************************************
# Subroutine Name         : createPid
# Objective               : This subroutine creates the pid.txt file for Scheduled Backup if it is not already running.
# Added By                : Vijay Vinoth
#**************************************************************************************************************************/
function createPid($taskType)
{
	GLOBAL $machine, $isLocalBackup, $fhsPid;
	$fhsPid = "";
	$isLocked = false;
	if($taskType == SCHEDULED){
		if($machine == TWOTIER){
			$startPidFile = "..".PATHSEPARATOR.MANUALTASK.PATHSEPARATOR.STARTPIDFILE;
			if(!isFileLocked($startPidFile)){
				traceLog("$jobrunningDir job is already running\n");
				exit;
			}		
		}		
		
		# create start id file
		$fhsPid = fopen(STARTPIDFILE, 'w+'); 
		if(!$fhsPid){
			traceLog("Unable to open file ".STARTPIDFILE.", Reason:".customErrorMsg());
			exit;
		}
	}
	else {								
		$fhsPid = fopen(STARTPIDFILE, 'w+');
			if(!$fhsPid){
			traceLog("Unable to open file ".STARTPIDFILE.customErrorMsg());
			exit;
		}
	}
	
	@chmod(STARTPIDFILE,PERMISSIONVAL);
	$isLocked = flock($fhsPid, LOCK_EX|LOCK_NB); 
	if(!$isLocked){			# $isLocked will be 0 if FHSPID is locked.
		traceLog("$jobrunningDir job is already running".customErrorMsg());
		exit;
	}
	
	# create process id file
	if(file_put_contents(PIDFILE," ") === FALSE){
		traceLog("Unable to open file ".PIDFILE.", Reason:".customErrorMsg());
		@unlink(STARTPIDFILE);
		@unlink(PIDFILE);
		exit;
	}
	@chmod(PIDFILE,PERMISSIONVAL);
}

#****************************************************************************************************************************
# Subroutine Name       : checkAndConstructXML
# Objective             : This subroutine is for xml parsing
# Added By              : Senthil Pandian [12/01/2016]
# Modified By			: 
#*****************************************************************************************************************************
function checkAndConstructXML($resultListXML){
	GLOBAL $lastLine;
	$exp = explode("\n",$resultListXML);
	$xml = '';
	foreach($exp as $data){
		if(!empty($data) && strpos($data,"<item")===false && strpos($data,"size=")===false){
			#traceLog("Not a XML: $data");
			if(!strrpos($data, ">")){
				$lastLine = $data.$lastLine; // Sometime partial data having "\n"
				#traceLog("lastLine: $lastLine");
			}
			continue;
		}
		$itemPos = strpos($data,"<item");
		$xml .= substr($data,$itemPos);
	}
	return $xml;
}

#**************************************************************************************************************************
# Subroutine Name         : checkBinaryExists
# Objective               : This subroutine checks if evs binary exists and whether it is executable.
# Added By                : Vijay Vinoth
#**************************************************************************************************************************/
function checkBinaryExists()
{
	GLOBAL $idevsutilBinaryPath, $logOutputFilePath;
	$errMsg = "";	
	
	if(!is_file($idevsutilBinaryPath))
		$errMsg = "idevsutil file does not exist in current directory. Please copy idevsutil file to current directory.";
	else if(!is_executable($idevsutilBinaryPath))
		$errMsg = "idevsutil file does not have executable permission. Please give it executable permission.";

	if($errMsg != ""){
		traceLog("ERROR: $errMsg");
		if(!file_put_contents($logOutputFilePath, $errMsg.PHP_EOL , FILE_APPEND | LOCK_EX))
		traceLog("Unable to open file $logOutputFilePath, Reason : ".customErrorMsg());
		
		@chmod($logOutputFilePath, PERMISSIONVAL);
		exitError('');
		exit;
	}
}

#****************************************************************************************************
# Subroutine Name         : checkDedupDeviceError.
# Objective               : Check dedup device id mismatch error & remove device id related files.
# Added By                : Senthil Pandian
#*****************************************************************************************************
function checkDedupDeviceError($error){
	GLOBAL $dedupDetailFile, $dedupRestoreDeviceID;
	if(stristr($error,"failed to get the device information") || stristr($error,"encryption verification failed")){
		@unlink($dedupDetailFile);
		@unlink($dedupRestoreDeviceID);
	}
}

#****************************************************************************************************
# Subroutine Name         : checkLastDayOfMonth.
# Objective               : Check today date is last day of month.
# Added By                : Pooja Havaldar
#*****************************************************************************************************
function checkLastDayOfMonth()
{
	GLOBAL $machine;
	$lastDay = "";
	if(TWOTIER == $machine){
		$lastDay = `date -v +1d +%d`;
		}
	elseif(QNAP == $machine or NETGEAR == $machine){
		$lastDay = `date +%d -d tomorrow`;
	}
	elseif(SYNOLOGY == $machine || ASUSTOR == $machine){
		$cmd = 'date -D "%s" -d $(( $(date +%s ) + 86400 )) +%d';
		$lastDay = `$cmd`;
	}
	$lastDay = trim($lastDay);
	if(1 == $lastDay){
		return true;
	}
	return false;
}

#****************************************************************************************************
# Subroutine Name         : configureAndCommitCron.
# Objective               : Configure and commit crontab.
# Added By                : Uttam Tiwari.
#*****************************************************************************************************/
function configureAndCommitCron()
{
	GLOBAL $machine;
	
	$returnVal = -1;	
	if($machine == QNAP){
		$returnVal = commitCrontabChanges();
		if($returnVal == 0){
			configureCron();
		}
	}
	if($machine == SYNOLOGY || $machine == ASUSTOR)
		configureCron();			
}

#*************************************************************************************************************
# Subroutine Name         : commitCrontabChanges
# Objective               : To reflect the changes made in crontab file
# Added By                : 
#**************************************************************************************************************/
function commitCrontabChanges()
{
	$retVal = 1;
	$retVal = system("/usr/bin/crontab /etc/config/crontab");
	if($retVal == "")
		$retVal = 0;
	else
		$retVal = 1;
	
	return $retVal;
}

#*************************************************************************************************************
# Subroutine Name         : configureCron
# Objective               :
# Added By                : 
#**************************************************************************************************************/
function configureCron()
{
	GLOBAL $machine;
	
	$retVal = 1;
	if(SYNOLOGY == $machine){
		$retVal = system("/usr/syno/sbin/synoservicectl --restart crond");	 
		# $? perl special variable to collect the error returned by system call
		if($retVal == ""){
			system("synoservice --restart crond");
			$retVal = 0;
		}
		else
			$retVal = 1;
	}
	else if($machine == ASUSTOR){
		system("./etc/init.d/S41crond stop");	
		system("./etc/init.d/S41crond start");	
	}
	else {
		$retVal = system("/etc/init.d/crond.sh restart");
		if($retVal == "")
			$retVal  = 0;
		else
			$retVal = 1;
	}
	//$retVal = $?;
	//$retVal = $retVal >> 8;
	return $retVal;

}

#****************************************************************************************************
# Subroutine Name         : copyError2Trace.
# Objective               : Copy any errors to Trace log that might occur while backup/restore.
# Added By                : Basavaraj Bennur.
# Modified By 			  : Avinash Kumar(02-JUN-2016)
#*****************************************************************************************************/
function copyError2Trace(&$errorPath)
{
	if(customFileSize($errorPath) > 0){
		$cancelData = "SIGTERM";
		$errorPattern = "unauthorized user";
		$content = file_get_contents($errorPath);
		if(preg_match("/$cancelData/", $content)){
			$cancelFlag = true;
			$errStr = $userCancelStr;
		} # handling wrong server address error message	
		elseif(preg_match("/$errorPattern/", $content)){
			updateServerAddr();
		}
	}
}

#****************************************************************************************************
# Subroutine Name         : customFileSize.
# Objective               : Check File size. If file is more that 2GB in 32 bit machine filesize will not work.
# Added By                : Vijay Vinoth
#*****************************************************************************************************/
function customFileSize($path)
{
	$file_size = filesize("$path");
	if($file_size < 0){
		GLOBAL $machine;
		$lsPath = 'ls -aln';
		if($machine == NETGEAR)
			$lsPath = getAppPath()."/ls -aln";

		$output = shell_exec("$lsPath \"$path\"");
		$split = preg_split('/\s+/', $output,6);
		$file_size = trim($split[4]);
	}
	return $file_size;
}

#****************************************************************************************************
# Subroutine Name         : customErrorMsg.
# Objective               : Check File size. If file is more that 2GB in 32 bit machine filesize will not work.
# Added By                : Vijay Vinoth
#*****************************************************************************************************/
function customErrorMsg(){
	$errorMsg = error_get_last();	
	return $errorMsg['message'];
}

//-------------------------------------- D ------------------------------------------------



//-------------------------------------- E ------------------------------------------------
#****************************************************************************************************
# Subroutine Name         : exitError.
# Objective               : To remove the temporary files created and exit 
# Added By                : Uttam Tiwari.
#*****************************************************************************************************/
function exitError($errStr = '')
{
	traceLog($errStr);
	unlink(PIDFILE);
	unlink(STARTPIDFILE);
	$rmCmd = "rm -rf ".ERROR_DIR." ".TEMP_FILES;
	`$rmCmd`;
}


//-------------------------------------- F ------------------------------------------------



//-------------------------------------- G ------------------------------------------------
/****************************************************************************************************
* Function Name         : getWebDirPath
* Objective             : Returns the Web directory path according to machine
* Added By              : Senthil Pandian
******************************************************************************************************/	
function getWebDirPath()
{
	GLOBAL $webDir,$machine;
		
	$servicePath = "$webDir";
	
	if(SYNOLOGY == $machine)
		$servicePath = readlink("$webDir");

	return $servicePath;
}

#****************************************************************************************************
# Subroutine Name         : getJobName.
# Objective               : This subroutine gets the current working JobName from job running directory
# Added By                : Pooja Havaldar
# Modified By			  : Senthil Pandian
#*****************************************************************************************************/
function getJobName()
{
	GLOBAL $username,$jobrunningDir;
	$arr = explode($username, $jobrunningDir);
    $jobName = explode('/', $arr[1]);
    $jobName = $jobName[2];
	return $jobName;
}
#******************************************************************************************************************************
# Subroutine Name         : getJobTerminationCommand
# Objective               : This function creates the Job Termination command for Backup/Restore/Local Search/Remote Search/Delete 
#							depending on machine name
# Added By                : Pooja Havaldar
# Modified By			  : Avinash kumar(02-JUN-2016, Removed return statement from each if block and put to last)
#******************************************************************************************************************************/
function getJobTerminationCommand($jobPath, $jobtype)
{
	GLOBAL $machine, $psPath;
	$jobStatusCmd = "";
	
	if($machine == QNAP){
		if($jobtype == "BACKUP_RESTORE_REMOTESEARCH_CLEANUP")
			$jobStatusCmd = "grep $jobPath /proc/*/cmdline" ;
		elseif($jobtype == "LOCALSEARCH")
			$jobStatusCmd = "grep $jobPath /proc/*/cmdline | grep find";
		else 
			$jobStatusCmd = "grep \"Delete\" /proc/*/cmdline";
	}
	else {
		if($jobtype == "BACKUP_RESTORE_REMOTESEARCH_CLEANUP")
			$jobStatusCmd = "$psPath | grep $jobPath | grep idevsutil_IDrive";
		elseif($jobtype == "LOCALSEARCH")
			$jobStatusCmd = "$psPath | grep \"find\" | grep $jobPath";
		else 
			$jobStatusCmd = "$psPath | grep Delete";		
	}
	
	return $jobStatusCmd ;
}
#******************************************************************************************************************
# Subroutine Name         : getLocalFilePath.
# Objective               : This subroutine returns the full file path
# Added By                : Pooja Havaldar
# Modified By			  : Senthil Pandian
#******************************************************************************************************************/
function getLocalFilePath($filePath)
{
	GLOBAL $machine;
	if(TWOTIER == $machine){
		$filePath = "/BackupData$filePath";
	}
	return $filePath;
}
#******************************************************************************************************************
# Subroutine Name         : getNAShostname.
# Objective               : This subroutine return host name.
# Added By                : Senthil Pandian [11/24/2016]
# Modified By			  : 
#******************************************************************************************************************/
function getNAShostname()
{
	GLOBAL $machine;
	$hostName = '';
	if($machine==TWOTIER){
		if(file_exists('/'.MPC_FILE)){			
			$hostName = file_get_contents('/'.MPC_FILE);
			$hostName = trim("/$hostName");
		}
	
		if(empty($hostName)){
			$hostName = shell_exec("hostname");
			#traceLog(MPC_FILE . "#$hostName#");
		}
	} else {
		$hostName = shell_exec("hostname");
	}
	$hostName = trim($hostName);
	return $hostName;
}
#******************************************************************************************************************
# Subroutine Name         : getOperationStatus
# Objective               : This fills the status of backup/restore operation status e.g SUCCESS, Failure etc.
# Added By                : Pooja Havaldar
# Modified By			  :	
#******************************************************************************************************************/
function getOperationStatus()
{
	GLOBAL $cancelFlag, $status, $filesConsideredCount;
	GLOBAL $successFiles, $syncedFiles, $failedFiles;

	$status = "FAILURE";
	if($cancelFlag == true)
		$status = "ABORTED";
	elseif($filesConsideredCount > 0 and ($filesConsideredCount == $successFiles+$syncedFiles+$failedFiles))		# if backup/restore operation has attempted backup/restore for all files
		$status = ($failedFiles == 0) ? "SUCCESS" : "FAILURE";
}

#****************************************************************************************************
# Subroutine Name         : getParameterValueFromStatusFile.
# Objective               : Fetches the value of individual parameters which are specified in the 
#                           StatusFile.
# Added By                : Arnab Gupta
# Modified By			  : Deepak Chaurasia, Senthil Pandian
#*****************************************************************************************************/
function getParameterValueFromStatusFile($index)
{
	GLOBAL $statusFileHash;

	if(count($statusFileHash) == 0)
		readStatusFile();
	
	if(isset($statusFileHash[$index]))
		return $statusFileHash[$index];
	
	return 0;
}
#****************************************************************************************************
# Subroutine Name       : getPhpPath.
# Objective             : This function will return full path for PHP based on machine type
# Added By              : Senthil Pandian [11/28/2016]
# Modified By			: 
#*****************************************************************************************************/
function getPhpPath()
{
	GLOBAL $machine,$phpPath;
	if(TWOTIER == $machine){
		$phpPath = "/usr/pbi/idrive-amd64/bin/php";
	} else {	
		$phpPath = `which php`;
		$phpPath = trim($phpPath);
		if($phpPath == ""){
			if(QNAP == $machine)
				$phpPath = "/mnt/ext/opt/apache/bin/php";
			else if(SYNOLOGY == $machine || NETGEAR == $machine)
				$phpPath = "/usr/bin/php";
			else if(ASUSTOR == $machine)
				$phpPath = "/usr/builtin/bin/php";
		}
	}
	return $phpPath.PHP_IGNORE_OPENBASEDIR;	
}
#******************************************************************************************************************
# Subroutine Name         : getPrintItem.
# Objective               : This subroutine return path after 1st level in case of twotier.
# Added By                : Avinash Kumar.
#******************************************************************************************************************/
function getPrintItem($item)
{
	GLOBAL $machine;
	if(TWOTIER == $machine)
		$item = preg_replace("/^\/BackupData/", "", $item);
	return $item;
}

function getRestoreLocation(){	
	GLOBAL $machine, $userDir;

	$restoreFile = "$userDir/restore_location.txt";
	$restorePathName = "";
	if(file_exists($restoreFile))
    {
      $restorePathName = file_get_contents($restoreFile);
    }
    else
    {
		if($machine == TWOTIER){
			$restorePathName = "$userDir/".DEFAULT_RESTORE_LOCATION;
		}
		else {
			$restorePathName = "/RestoredData/Default/";
		}
      file_put_contents($restoreFile,$restorePathName);
	  @chmod($restoreFile, PERMISSIONVAL);
    }
	return $restorePathName;
}
#****************************************************************************************************
# Subroutine Name         : getHeaderMsg.
# Objective               : This subroutine returns string with machine name, backup type and hidden
#							file information in case of NAS backup and return machine id for vault 
#							backup. Returns machine name or id dependes on NAS or vault restore.
# Modified By             : Vijay Vinoth
#*****************************************************************************************************/
function getHeaderMsg($operationType = '',$hidden = '')
{
	GLOBAL $host,$machine,$operationName,$taskType,$deDup;
	$header = "";
	
	$jobName = getJobName();
	$throttle = getThrottleValue();
		
	if($machine == TWOTIER){
		$header = "Machine Id: $host ".LINEFEED."Throttle Value: $throttle".LINEFEED;
	return $header;
	}
	
	if($operationName == BACKUP){
		$backupType = '';
		if($deDup != true)
			$backupType = "Backup Type: $operationType".LINEFEED;
		
		$header = 	$backupType."Show hidden files and folders: $hidden".LINEFEED;
	}
	
	if($taskType != MANUAL)
		$header .= "Schedule $operationName Job: $jobName".LINEFEED;

	$header .= 	"Machine Name: $host".LINEFEED."Throttle Value: $throttle".LINEFEED;

	return $header;
}

#******************************************************************************************************************
# Subroutine Name         : getAppPath
# Objective               : Get package path
# Added By                : Deepak Chaurasia
#******************************************************************************************************************/
function getAppPath()
{
	GLOBAL $machine, $webDir;
	$appPath = "";
	if($machine == TWOTIER)
		$appPath = "/usr/pbi/idrive-amd64/www/idrive";
	else
		$appPath = "$webDir/".APPDIR;
	return $appPath;
}

#****************************************************************************************************
# Subroutine Name         : getThrottleValue.
# Objective               : This subroutine gets the Throttle Value
# Modified By             : Vijay Vinoth
#*****************************************************************************************************/
function getThrottleValue()
{
	GLOBAL $userDir;
	$bandwidthFilePath = "$userDir/.bw.txt";
	$throttle = 100;
	if(file_exists($bandwidthFilePath)){
		$throttle = file_get_contents($bandwidthFilePath);
		trim($throttle);
	}
	
	if($throttle == "")
		$throttle = 100;

	return $throttle;
}
/****************************************************************************************************
* Subroutine Name         : getUserName.
* Objective               : Get current user logged on with IDrive account.
* Added By                : Avinash Kumar
* Modified By			  : Senthil Pandian
******************************************************************************************************/
function getUserName($currentPath = '')
{
	if($currentPath == '') 
		$currentPath = getcwd();
	
	# try to find the user name from currentPath
	$needle				= "/" . SERVICE . "/" . USER_PROFILE . "/";
	$tmp				= explode($needle, $currentPath);
	
	if(count($tmp) > 1) {
		$splitPath 		= explode("/" , $tmp[1]);
		return $splitPath[0];
	}
	
	# Following condition needed when it runs from command line[Ex: send mail]
	GLOBAL $username;
	if($username != '') {
		return $username;
	}	

	return '';
}

#****************************************************************************************************
# Subroutine Name         : getVars.
# Objective               : Get machine information from config file. 
# Added By                : Uttam Tiwari
# Modified By			  : Senthil Pandian
#*****************************************************************************************************/
function getVars()
{
	$file = NULL;
	$configFile = dirname(dirname(__FILE__)).PATHSEPARATOR.CONFIG.PATHSEPARATOR.CONFIG_FILE;
	if (file_exists($configFile)) {
		$file = fopen($configFile ,"r");
	}

	if(!$file) {
		loadMachineConfigurations();
	}
	
	$hash = array();
	while(! feof($file)) {
		$pair = preg_split ('/\s+/',fgets($file),2);
		$hash[array_shift($pair)] = array_shift($pair);
	}
	
	fclose($file);
	
	GLOBAL $machine;
	$machine 		= $hash['machine'];

	$_SESSION['webDir'] 	= $hash['webDir'];
	$_SESSION['nasUser'] 	= $hash['user'];
	$_SESSION['machine'] 	= $machine;
	$pair = preg_split ('/\s+/',$hash['cronCat']);
	$hash['cronCat'] =  $pair[1];
	$_SESSION['cronCat'] 	= $hash['cronCat'];
	return $hash;
}



#******************************************************************************************************************
# Subroutine Name         : getSource.
# Objective               : This subroutine return source respective to machine.
# Added By                : Avinash Kumar.
#******************************************************************************************************************/
function getSource()
{
	GLOBAL $machine;
	$source = "";
	if(TWOTIER == $machine)
		$source = "/BackupData/";
	else
		$source = "/";
	return $source;
}

#****************************************************************************************************
# Subroutine Name         : getParameterValueFromAccountSettingsFile.
# Objective               : Fetches the value of individual parameters which are specified in the 
#                           Account Settings file.
# Added By                : Arnab Gupta.
#*****************************************************************************************************/
function getParameterValueFromAccountSettingsFile(&$key, &$value)
{
	GLOBAL $linesAccountSettingsFile;
	if (count($linesAccountSettingsFile) == 0) {
		readAccountSettingsFile();
	}
	
	foreach($linesAccountSettingsFile as $line){
		if(preg_match("/$key/", $line)){
			$keyValuePair = preg_split('/=/', $line);
			$value = $keyValuePair[1];
			$value = trim($value);
			break;
		}
	}
}

#****************************************************************************************************
# Subroutine Name         : getProxyString.
# Objective               : Reads Account Settings file and returns the proxy details if set or 
#			   				returns empty otherwise.
# Added By                : Vijay Vinoth.
#*****************************************************************************************************/
function getProxyString()
{	
	GLOBAL $userDir;
	
	$proxyPath = "$userDir/ACCOUNT_SETTINGS_FILE";
	if(! file_exists($proxyPath)){
		return "";
	}
	
	$tempString = file_get_contents($proxyPath);
	$tempString = explode("\n", $tempString);
	$proxyString = array();
	$len  = count($tempString);
	for ($index = 0; $index < $len; $index++){
		if(preg_match("/PROXY = /", $tempString[$index])){
			$proxyString = preg_split("/PROXY = /", $tempString[$index]);
		}        
	}

	#Need to check with Senthil. 
	if(count($proxyString) > 0){
		$proxyString[1] = str_replace("\%([A-Fa-f0-9]{2})","pack('C', hex($1))", $proxyString[1]); #decode the string which was encoded in php
		$proxyString[1] = str_replace("\R", "", $proxyString[1]);
		return $proxyString[1];
	}
	return "";
}

#****************************************************************************************************
# Subroutine Name         : getProxyToValidate.
# Objective               : Reads entermediate file returns the proxy details.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
function getProxyToValidate()
{
	GLOBAL $userDir;
	
	$authFilePath = "$userDir/.idriveAuthParams.txt";
	$proxyData = "";
	$content = "";

	$contentArr = array();
	$contentArr = file($authFilePath);
	$len = count($contentArr);
	
	if(preg_grep("/proxy/", $contentArr)){	
		$proxyData = "\'".$contentArr[$len - 1]."\'".":"."\'".$contentArr[$len - 2]."\'"."@".$contentArr[$len - 3].":".$contentArr[$len - 4];
	}
	$encTypeDir = $contentArr[3];
	return $proxyData;
}

#********************************************************************************************************************
# Subroutine Name         : getOperationFile.
# Objective               : Create utf8 file for EVS command respective to operation type(backup/restore/validate...).
# Added By                : Avinash Kumar.
#********************************************************************************************************************/
function getOperationFile($operationType, $BackupsetFile = "", $backupType = "", $source = "")
{
	GLOBAL $bandwidthFilePath;
	GLOBAL $hostNameLB, 		$username;
	GLOBAL $userDir, 			$hashEvsParameters;
	GLOBAL $backupLocation, 	$trash;
	GLOBAL $serverAddress,		$dedupDetailFile;
	GLOBAL $dedupRestoreDeviceID;
	
	$opType = "";
	$utfFile = "";
	$utfValidate = "";	
	$encPwdPath = $userDir.PATHSEPARATOR."IDPWD";
	$encPvtkeyPath = $userDir.PATHSEPARATOR."IDPVT";
	$utfPath = $userDir.PATHSEPARATOR.UTFFILE;
	$currentDir = `pwd`;
	$currentDir = trim($currentDir);
	$bck_res_utf8 = $currentDir.PATHSEPARATOR.UTFFILE;
	$sreverAddrPath = $userDir.PATHSEPARATOR.SERVER_ADDR_PATH;
	$proxyString = getProxyString();
	$RestoresetFile = "./RestoresetFile.txt";
	$serverAddress = "";
	$serverAddressOperator = "@";
	$serverName = "home";
	$serverNameOperator = "::";
	$privateEncryptionKey = "Private";
	$encryptionType = "";
	$deDupDevideId = "";

	if($operationType != GETSERVERADDRESS){
		if(!file_exists($sreverAddrPath) or customFileSize($sreverAddrPath) <= 0)
			updateServerAddr();
		
		# get server address
		if(!($SERVERHDL = fopen($sreverAddrPath, "r"))){
			traceLog("Unable to open file $sreverAddrPath Reason: ".customErrorMsg());
			$serverAddress = updateServerAddr();
		}
		else {
			$serverAddress = fread($SERVERHDL, customFileSize($sreverAddrPath));
			fclose($SERVERHDL);
		}
		$serverAddress = trim($serverAddress);
	}
	
	$key = "encType";
	getParameterValueFromAccountSettingsFile($key,$encryptionType);
	$deDup = false;
	$deviceID = '';
	$restoreDeviceID ='';
	if(file_exists($dedupDetailFile)){
		$deDup = true;
		$deviceID = file_get_contents($dedupDetailFile);
		$deviceID = trim($deviceID);
		
		if(file_exists($dedupRestoreDeviceID)){
			$restoreDeviceID = file_get_contents($dedupRestoreDeviceID);
			$restoreDeviceID = trim($restoreDeviceID);
		}		
	}
	
		if($deDup && $restoreDeviceID!='')
			$deDupDevideId = $hashEvsParameters["DEVICE_ID"].ASSIGNMENTOP.$restoreDeviceID.LINEFEED;
			
		
	if($operationType == BACKUP)
	{	
		if(!($UTF8FILE = fopen($bck_res_utf8, "w"))){
			traceLog("Unable to open file $bck_res_utf8 Reason: ".customErrorMsg());
			exit;
		}
		
		$utfFile = $hashEvsParameters["FROMFILE"].ASSIGNMENTOP.$BackupsetFile.LINEFEED.
   			    $hashEvsParameters["BWFILE"].ASSIGNMENTOP.$bandwidthFilePath.LINEFEED.
   			    $hashEvsParameters["TYPE"].LINEFEED.
   			    $hashEvsParameters["PASSWORD"].ASSIGNMENTOP.$encPwdPath.LINEFEED;
				
		if($encryptionType === $privateEncryptionKey)
			$utfFile .= $hashEvsParameters["PVTKEY"].ASSIGNMENTOP.$encPvtkeyPath.LINEFEED;
		
		$input = $backupLocation;
		if($deDup){
			$utfFile .= $hashEvsParameters["DEVICE_ID"].ASSIGNMENTOP.$deviceID.LINEFEED;
			$input = '';
		}
		
		$utfFile .= $hashEvsParameters["ADDPROGRESS"].LINEFEED.
	    $hashEvsParameters["PROXY"].ASSIGNMENTOP.$proxyString.LINEFEED.
		$hashEvsParameters["ENCODE"].LINEFEED.
		$backupType.LINEFEED.
		$hashEvsParameters["XMLOUTPUT"].LINEFEED.	
		$hashEvsParameters["OUTPUT"].ASSIGNMENTOP.OUTPUTFILE.LINEFEED.
	    $hashEvsParameters["ERROR"].ASSIGNMENTOP.ERRORFILE.LINEFEED.
		$source.LINEFEED.
		$username.$serverAddressOperator.
	    $serverAddress.$serverNameOperator.
	    $serverName.$input.PATHSEPARATOR.LINEFEED;
		fwrite($UTF8FILE, $utfFile);
        fclose($UTF8FILE);
		@chmod($bck_res_utf8, PERMISSIONVAL);
		traceLog("$operationType has been executed\n");
        return $bck_res_utf8;
	}
	elseif($operationType == LOCALBACKUP){
		$bandwidthFilePath = "$userDir/.bw.txt";
		$relStr = "";
		$localMPC = getNAShostname();
		$host = "$backupLocation/$username/$localMPC";
		if(!($UTF8FILE = fopen($bck_res_utf8, "w"))){
			traceLog("Unable to open file $bck_res_utf8 Reason: ".customErrorMsg());
			exit;
		}

		$utfFile = $hashEvsParameters["FROMFILE"].ASSIGNMENTOP.$BackupsetFile.LINEFEED.
	   			   $hashEvsParameters["BWFILE"].ASSIGNMENTOP.$bandwidthFilePath.LINEFEED.
	   			   $hashEvsParameters["TYPE"].LINEFEED.
	   			   $hashEvsParameters["PASSWORD"].ASSIGNMENTOP.$encPwdPath.LINEFEED;
				   
		if($encryptionType === $privateEncryptionKey){
			$utfFile .= $hashEvsParameters["PVTKEY"].ASSIGNMENTOP.$encPvtkeyPath.LINEFEED;
		}
		
		$utfFile .= $hashEvsParameters["ADDPROGRESS"].LINEFEED.
			    	$hashEvsParameters["PROXY"].ASSIGNMENTOP.$proxyString.LINEFEED.
    			    $hashEvsParameters["ENCODE"].LINEFEED.
					$backupType.LINEFEED.
					$hashEvsParameters["OUTPUT"].ASSIGNMENTOP.OUTPUTFILE.LINEFEED.
			    	$hashEvsParameters["ERROR"].ASSIGNMENTOP.ERRORFILE.LINEFEED.
					$hashEvsParameters["XMLOUTPUT"].LINEFEED.
					$hashEvsParameters["ENCOPT"].LINEFEED.
					$hashEvsParameters["PORTABLE"].LINEFEED.
					$hashEvsParameters["NOVERSIONS"].LINEFEED.
					$hashEvsParameters["PORTABLEDEST"].ASSIGNMENTOP.$host.LINEFEED.
					$source.LINEFEED.
					$username.$serverAddressOperator.
			    	$serverAddress.$serverNameOperator.
			    	$serverName.PATHSEPARATOR.$host.PATHSEPARATOR.LINEFEED;
		fwrite($UTF8FILE, $utfFile);
		fclose($UTF8FILE);
		@chmod($bck_res_utf8, PERMISSIONVAL);
		traceLog("$operationType has been executed\n");
		return $bck_res_utf8;
	}
	else if($operationType == RESTORE)
	{
		$host = $source;
		$RestoresetFile = $BackupsetFile;
		if(!($UTF8FILE = fopen($bck_res_utf8, "w"))){
			traceLog("Unable to open file $bck_res_utf8 for restore, Reason: ".customErrorMsg());
		}
		$utfFile = $hashEvsParameters['FROMFILE'].ASSIGNMENTOP.$RestoresetFile.LINEFEED;
				if($trash == 1){
					$utfFile .= "--trash".LINEFEED;
				}
			$utfFile .= $hashEvsParameters['TYPE'].LINEFEED.
						$hashEvsParameters['PASSWORD'].ASSIGNMENTOP.$encPwdPath.LINEFEED;
		if($encryptionType === $privateEncryptionKey){
			$utfFile .= $hashEvsParameters['PVTKEY'].ASSIGNMENTOP.$encPvtkeyPath.LINEFEED;
		}
		$restorelocation = getRestoreLocation();
		$utfFile .= $hashEvsParameters['ADDPROGRESS'].LINEFEED.
			    $hashEvsParameters['PROXY'].ASSIGNMENTOP.$proxyString.LINEFEED.
   			    $hashEvsParameters['ENCODE'].LINEFEED.
				$hashEvsParameters["XMLOUTPUT"].LINEFEED;
		
		if($backupType ==  NORELATIVE){
			$utfFile .= NORELATIVE.LINEFEED;
		}
		$utfFile .= $deDupDevideId;
		
   		$utfFile .= $hashEvsParameters['OUTPUT'].ASSIGNMENTOP.OUTPUTFILE.LINEFEED.
					$hashEvsParameters['ERROR'].ASSIGNMENTOP.ERRORFILE.LINEFEED.
					$username.$serverAddressOperator.
					$serverAddress.$serverNameOperator.
					$serverName.$host.LINEFEED.
					$restorelocation.LINEFEED;
					
		fwrite($UTF8FILE, $utfFile);
		fclose($UTF8FILE);
		@chmod($bck_res_utf8,PERMISSIONVAL);
		traceLog("$operationType has been executed\n");
		return $bck_res_utf8;
	}
	else if($operationType == LOCALRESTORE)
	{
		$RestoresetFile = $BackupsetFile;
		$destPath = $hostNameLB."/$username$source";
		
		if(!($UTF8FILE = fopen($bck_res_utf8, "w"))){
			traceLog("Unable to open file $bck_res_utf8 for restore, Reason: ".customErrorMsg());
		}
		$utfFile = $hashEvsParameters['FROMFILE'].ASSIGNMENTOP.$RestoresetFile.LINEFEED.
	   			   $hashEvsParameters['TYPE'].LINEFEED.
	   			   $hashEvsParameters['PASSWORD'].ASSIGNMENTOP.$encPwdPath.LINEFEED;
		if($encryptionType === $privateEncryptionKey){
			$utfFile .= $hashEvsParameters['PVTKEY'].ASSIGNMENTOP.$encPvtkeyPath.LINEFEED;
		}
		$restorelocation = getRestoreLocation();
		$utfFile .= $hashEvsParameters['ADDPROGRESS'].LINEFEED.
				    $hashEvsParameters['PROXY'].ASSIGNMENTOP.$proxyString.LINEFEED.
				    $hashEvsParameters['ENCODE'].LINEFEED.
					$hashEvsParameters["XMLOUTPUT"].LINEFEED;
		
		if($backupType == NORELATIVE){
			$utfFile .= NORELATIVE.LINEFEED;
		}
		
   		$utfFile .= $hashEvsParameters['OUTPUT'].ASSIGNMENTOP.OUTPUTFILE.LINEFEED.
					$hashEvsParameters['ERROR'].ASSIGNMENTOP.ERRORFILE.LINEFEED.
					$hashEvsParameters['MASKNAME'].LINEFEED.
					$hashEvsParameters['ENCOPT'].LINEFEED.
					$hashEvsParameters['PORTABLE'].LINEFEED.
					$hashEvsParameters['PORTABLEDEST'].ASSIGNMENTOP.$destPath.LINEFEED.
					$username.$serverAddressOperator.
					$serverAddress.$serverNameOperator.
					$serverName.$destPath.LINEFEED.
					$restorelocation.LINEFEED;
		
		fwrite($UTF8FILE, $utfFile);
		fclose($UTF8FILE);
		@chmod($bck_res_utf8, PERMISSIONVAL);
		traceLog("$operationType has been executed\n");
		return $bck_res_utf8;
	}
	else if($operationType == SEARCH)
	{
		$searchUtfPath = "utf8.txt";
		$searchPatteren = $BackupsetFile;
		if(!($UTF8FILE = fopen($searchUtfPath, "w"))){
			traceLog("Unable to open file $searchUtfPath for auth list, Reason: ".customErrorMsg());
		}
		$utfFile = $hashEvsParameters['PASSWORD'].ASSIGNMENTOP.$encPwdPath.LINEFEED;
		if($trash == 1){
			$utfFile .= "--trash".LINEFEED;
		}
		$utfFile .= $deDupDevideId;
		
		$utfFile .= $hashEvsParameters['PROXY'].ASSIGNMENTOP.$proxyString.LINEFEED.
					$hashEvsParameters['ENCODE'].LINEFEED.
					$hashEvsParameters['OUTPUT'].ASSIGNMENTOP.OUTPUTFILE.LINEFEED.
					$hashEvsParameters['ERROR'].ASSIGNMENTOP.ERRORFILE.LINEFEED.
					$hashEvsParameters['SEARCH'].LINEFEED.
					$hashEvsParameters["XMLOUTPUT"].LINEFEED;
		# in case of resore search.
		# Note: this should be implement with archive cleanup.
		if($backupType == SEARCH_FOR_RESTORE){
			$utfFile .= $hashEvsParameters['FILE'].LINEFEED;
			if($deDup && $restoreDeviceID!=''){
				$utfFile .= $hashEvsParameters["DEVICE_ID"].ASSIGNMENTOP.$restoreDeviceID.LINEFEED;
				$searchPatteren .= "/";
			} 
			else
			$searchPatteren .= "/*";
		}
		$utfFile .= $username.$serverAddressOperator.
		$serverAddress.$serverNameOperator.
		$serverName.PATHSEPARATOR.$searchPatteren.LINEFEED;
		
		fwrite($UTF8FILE, $utfFile);
		fclose($UTF8FILE);
		@chmod($searchUtfPath, PERMISSIONVAL);
		traceLog("$operationType has been executed\n");
		return $bck_res_utf8;
	}
	else if($operationType == PROPERTIES)
	{
		if(!($UTF8FILE = fopen($utfPath, "w"))){
			traceLog("Unable to open file $utfPath for properties, Reason: ".customErrorMsg());
		}
		$utfFile = $hashEvsParameters['PASSWORD'].ASSIGNMENTOP.$encPwdPath.LINEFEED.
			   $hashEvsParameters['PROPERTIES'].LINEFEED.
			   $hashEvsParameters['PROXY'].ASSIGNMENTOP.$proxyString.LINEFEED.
		   	   $hashEvsParameters['ENCODE'].LINEFEED.
			   $hashEvsParameters['ERROR'].ASSIGNMENTOP.ERRORFILE.LINEFEED.
			   $deDupDevideId.
		   	   $username.$serverAddressOperator.
		   	   $serverAddress.$serverNameOperator.
		   	   $serverName.$BackupsetFile;	
			   
		fwrite($UTF8FILE, $utfFile);
		fclose($UTF8FILE);	   
	}
	elseif($operationType == GETSERVERADDRESS)
	{ 
		$proxyData = "";
		$authFilePath = "$userDir/.idriveAuthParams.txt";
		if(file_exists($authFilePath) and 0 < customFileSize($authFilePath)){
			$proxyData = getProxyToValidate();		# only this call was there
		}
		
		if(!($UTF8FILE = fopen($utfPath, "w"))){
			traceLog("Unable to open file $utfPath Reason: ".customErrorMsg());
			exit;
		}
		$utfFile = $hashEvsParameters["SERVERADDRESS"].LINEFEED.
			   $username.LINEFEED.
			   $hashEvsParameters["PASSWORD"].ASSIGNMENTOP.$encPwdPath.LINEFEED.
		           $hashEvsParameters["PROXY"].ASSIGNMENTOP.$proxyData.LINEFEED.
			   $hashEvsParameters["ENCODE"].LINEFEED.
			   $hashEvsParameters["ERROR"].ASSIGNMENTOP.ERRORFILE.LINEFEED;
			   
		fwrite($UTF8FILE, $utfFile);
		fclose($UTF8FILE);
	}
	else {
		traceLog("Invalid Operation Type For Utf8 File");
	}
	@chmod($utfPath,PERMISSIONVAL);
	traceLog("$operationType has been executed\n");
	return $utfPath;
}

#******************************************************************************************************************
# Subroutine Name         : getDirList.
# Objective               : get one level listing of particular dir path
# Added By                : Pooja Havaldar
#******************************************************************************************************************/
function getDirList($ArchiveJobPath)
{
	$files_list = array();
	$files_list = scandir($ArchiveJobPath);
	return $files_list;
}

/************************************************************************************************
* Subroutine Name : getMachineDetails
* Objective       : Prepare the NAS machine details
* Added By        : Yogesh Kumar
* Modified By     : Senthil Pandian
************************************************************************************************/
function getMachineDetails() {
	if (($machinePattern = getMachinePattern()) !== FALSE) {
		GLOBAL $machine;
		$machineDetails = array();
		$machineDetails['documentroot'] = $machinePattern[0];
		$machine                        = $machinePattern[1];
		switch($machine) {
			case SYNOLOGY:
			$machineDetails['cronCat']      = 'cat /etc/crontab';
			$machineDetails['superuser']    = 'root';
			break;
			case QNAP:
			$machineDetails['cronCat']      = 'cat /etc/config/crontab';
			$machineDetails['superuser']    = 'admin';
			break;
			case NETGEAR:
			$machineDetails['cronCat']      = 'cat /etc/crontab';
			$machineDetails['superuser']    = 'root';
			break;
			case TWOTIER:
			$machineDetails['cronCat']      = 'cat /etc/crontab';
			$machineDetails['superuser']    = 'root';
			break;
		}
		return $machineDetails;
	}

	return FALSE;
}

/************************************************************************************************
* Subroutine Name : getMachinePattern
* Objective    	  : Finding the machine by verifying the current code path
* Added By    	  : Yogesh Kumar
* Modified By 	  : Senthil Pandian
************************************************************************************************/
function getMachinePattern() {
	GLOBAL $machine;
	$filePatterns = array();
	$filePatterns['/var/services/web'] = SYNOLOGY;
	$filePatterns['/share/Web'] = QNAP;
	$filePatterns['/share/Qweb'] = QNAP;
	$filePatterns['/apps/idrive/web'] = NETGEAR;
	$filePatterns['/usr/local/www'] = TWOTIER;

	$machinePattern = NULL;
	foreach($filePatterns as $key => $machine) {
		if($machine===QNAP || $machine===TWOTIER){
			if(file_exists($key."/".APPDIR) && dirname(dirname(__FILE__)) == readlink($key."/".APPDIR)) {
				$machinePattern = array($key, $machine);
				break;
			}
		}

		if($machine===SYNOLOGY){
			if(file_exists($key."/".APPDIR) && dirname(dirname(__FILE__)) == readlink($key."/".APPDIR)) {
				// For Production
				$machinePattern = array($key, $machine);
				break;
			}
			else if(file_exists($key."/".APPDIR) && dirname(dirname(__FILE__)) == readlink($key)."/".APPDIR)
			{
				// For APP Path customization
				$machinePattern = array($key, $machine);
				break;
			}
		}

		if($machine===NETGEAR){
			if (dirname(dirname(dirname(__FILE__))) == $key){
				$machinePattern = array($key, $machine);
				break;
			}
		}
	}

	if ($machinePattern == NULL) {
		return FALSE;
	}
	return $machinePattern;
}

//-------------------------------------- H ------------------------------------------------



//-------------------------------------- I ------------------------------------------------
/************************************************************************************************
* Subroutine Name : isFileLocked
* Objective    	  : To find out whether the given file is locked or not.
* Added By    	  : Pooja Havaldar
* Modified By 	  : 
* Modified On 	  : 
************************************************************************************************/
function isFileLocked($fileName)
{
	if(!file_exists($fileName)){
		return false;
	}
	
	$handle = fopen($fileName,'a');
	if(!flock($handle,LOCK_EX|LOCK_NB)){			#flock returns false if file is already locked.
	fclose($handle);
	return true;
	}
	
	fclose($handle);
	return false;
}


//-------------------------------------- J ------------------------------------------------



//-------------------------------------- K ------------------------------------------------



//-------------------------------------- L ------------------------------------------------
/************************************************************************************************
* Subroutine Name	: loadMachineConfigurations
* Objective		: Load the NAS machine configurations.
* Added By		: Yogesh Kumar
* Modified By 	    : Senthil Pandian
************************************************************************************************/
function loadMachineConfigurations() {
	GLOBAL $machine;
	$machineDetails = getMachineDetails();

	$_SESSION['webDir']     = $machineDetails['documentroot']; // Path to our Application's root directory
	$_SESSION['nasUser']    = $machineDetails['superuser'];    // Name of the super user of this machine
	$_SESSION['machine']    = $machine;                        // NAS machine name, where this app is installed in
	
	$configFileContent = ("webDir " . $_SESSION['webDir'] . "\n");
	$configFileContent .= ("user " . $_SESSION['nasUser'] . "\n");
	$configFileContent .= ("machine " . $_SESSION['machine'] . "\n");
	$configFileContent .= ("cronCat " . $machineDetails['cronCat'] . "\n");
	$configFile  		= dirname(dirname(__FILE__)).PATHSEPARATOR.CONFIG.PATHSEPARATOR.CONFIG_FILE;
	file_put_contents($configFile, $configFileContent);
	@chmod($configFile,PERMISSIONVAL);
	return TRUE;
}



//-------------------------------------- M ------------------------------------------------



//-------------------------------------- N ------------------------------------------------



//-------------------------------------- O ------------------------------------------------



//-------------------------------------- P ------------------------------------------------
/*********************************************************************************************************
* Subroutine Name       : phpQuoteMeta
* Objective             : Perl quotemeta replacement in PHP
* Added By              : Sabin Cheruvattil | 2016-11-30
**********************************************************************************************************/
function phpQuoteMeta($pattern)
{
	return addcslashes($pattern, '\-^$.[]|()?*+{} //');
}

#****************************************************************************************************
# Subroutine Name         : parseXMLOutput.
# Objective               : Parse evs command output.
# Added By                : Arnab Gupta.
#*****************************************************************************************************/
function parseXMLOutput(&$commandOutput, &$totalquota, &$pattern)
{
/* 
 if(!empty($commandOutput) and $commandOutput != ""){
    if(preg_match("/$pattern/", $commandOutput)){
      if($' =~ m/"[^"]+"/){
        my $paramVal = $&;
        $paramVal =~ s/^.//;
        $paramVal =~ s/.$//;

        ${$_[1]} = $paramVal;
      }
    }
  }
*/
}

//-------------------------------------- Q ------------------------------------------------



//-------------------------------------- R ------------------------------------------------
#****************************************************************************************************
# Subroutine Name         : readLocalBackupLocation.
# Objective               : Reads the local backup location from file
# Added By				  : Pooja H
# Modified By			  : Senthil Pandian
#*****************************************************************************************************/
function readLocalBackupLocation()
{  
	GLOBAL $localBackupLocationFile;
	if(!file_exists($localBackupLocationFile)){
		traceLog("\n $localBackupLocationFile doesn't exist. Reason : ".customErrorMsg());
		return false;
	}	
	$hostNameLB = file_get_contents($localBackupLocationFile);
	return $hostNameLB;
}
#****************************************************************************************************
# Subroutine Name         : readStatusFile.
# Objective               : reads the status file 
# Added By				  : Deepak Chaurasia
# Modified By			  : Senthil Pandian
#*****************************************************************************************************/
function readStatusFile()
{
	GLOBAL $statusFileHash;
	if(file_exists(STATUSFILE) && fileSize(STATUSFILE)>0){
		$file = fopen(STATUSFILE ,"r");	
		if($file) {
			while(! feof($file)) {
				$line = trim(fgets($file));
				$keyValuePair = preg_split('/=/',$line);
				if(count($keyValuePair)>=2){
					$keyValuePair[0]=trim($keyValuePair[0]);			
					$statusFileHash[$keyValuePair[0]] = trim($keyValuePair[1]);	
				}
			}
			fclose($file);
		} else {
			traceLog("Unable to open file ".STATUSFILE.", Reason:".customErrorMsg());
		}		
	}
}

#****************************************************************************************************
# Subroutine Name         : readBackupLocation.
# Objective               : Reads the backup location from file
# Added By                : Deepak Chaurasia
#*****************************************************************************************************/
function readBackupLocation()
{  
	GLOBAL $userDir, $machine;
	$mpcName = "";
	$mpcFile = "$userDir/mpc.txt";
	if(file_exists($mpcFile)){
		$mpc = fopen($mpcFile, "r");
		if($mpc){
			$mpcName = fread($mpc,customFileSize($mpcFile));
			fclose($mpc);
		} else
			traceLog("Unable to open file : $mpcFile, Reason:".customErrorMsg());
	}
	elseif(TWOTIER == $machine and file_exists("/".MPC_FILE)){
		$mpc = fopen("/".MPC_FILE, "r");
		if($mpc){			
			$mpcName = fread($mpc,customFileSize("/".MPC_FILE));
			fclose($mpc);
			$mpcName = "/".$mpcName;
		} else
			traceLog("Unable to open file : ".MPC_FILE.", Reason:$php_errormsg");

	}
	
	if(empty($mpcName)){				                                                                        
		$mpcName = `hostname`;
		chop($mpcName,"\n");
	}
	return $mpcName;	
}
#******************************************************************************************************************
# Subroutine Name         : readFromUserCancel.
# Objective               : read cancel.txt to write job cancel message in log
# Added By                : Avinash Kumar.
#******************************************************************************************************************/
function readFromUserCancel()
{
	$cancelMsg = "";
	
	if(file_exists(CANCEL_PATH))
		$cancelMsg = file_get_contents(CANCEL_PATH);
	return $cancelMsg;
}

#****************************************************************************************************
# Subroutine Name         : readAccountSettingsFile.
# Objective               : Reads the entire Account Settings File.
# Added By                : Arnab Gupta.
#*****************************************************************************************************/
function readAccountSettingsFile()
{  
	GLOBAL $linesAccountSettingsFile, $userDir;
	$linesAccountSettingsFile = file("$userDir/ACCOUNT_SETTINGS_FILE");
}
#***********************************************************************************************************************
# Subroutine Name       : replaceXMLcharacters
# Objective             : This subroutine replaces the special characters in XML output with their actual characters  
# Added By              : Senthil Pandian [12/01/2016]
# Modified By			: 
#************************************************************************************************************************
function replaceXMLcharacters(&$string,$type)
{
	GLOBAL $current_BackupsetHash;
	GLOBAL $current_RestoresetHash;
	$changedName = html_entity_decode($string);
	if($changedName!==$string){
		if($type==BACKUP){
			if(isset($current_BackupsetHash[$changedName])){
				$current_BackupsetHash[$changedName] = 1;
				return true;
			}
		} else {
			if(isset($current_RestoresetHash[$changedName])){
				$current_RestoresetHash[$changedName] = 1;
				return true;
			}			
		}
	}
	$string = $changedName;
	return false;
}
//-------------------------------------- S ------------------------------------------------
#******************************************************************************************************************
# Subroutine Name         : sendMail.
# Objective               : This subroutine sends a mail to the user in case of successful/cancelled/failed backup
# Added By                : Arnab Gupta
# Modified By 			  : Deepak Chaurasia, Pooja Havaldar
#******************************************************************************************************************/
function sendMail()
{
    GLOBAL $username;
    GLOBAL $operationName;
    GLOBAL $status;
    GLOBAL $headerMsg;
    GLOBAL $mailSummaryMsg;
    GLOBAL $taskType;
    GLOBAL $phpPath;
    GLOBAL $webDir;
    GLOBAL $jobrunningDir;
	
	$content = "";
	$mailStatus = "";
	
	if($taskType == MANUAL)
		return;
	
	trim($mailSummaryMsg,"\n");
	
	$content = "Dear IDriveUser, \n\n";
	$content .= "Ref: User name - $username \n\n";	
	$content .= $headerMsg.$mailSummaryMsg;
	$content .= "\n\nRegards,\nIDrive Support";
	$content = str_replace("'","'\\''", $content);
	
	if($status == "SUCCESS")
		$mailStatus = "Successful $operationName";
	elseif($status == "ABORTED")
		$mailStatus = "Cancelled $operationName";
	else
		$mailStatus = "Failed $operationName";
	
	$jobNameForMail = basename($jobrunningDir);
	$jobType  = "$operationName"."_";
	$cmd_mail = "$phpPath $webDir".PATHSEPARATOR.APPDIR.PATHSEPARATOR.CONFIG.PATHSEPARATOR.SENDMAILFILE." '$username' '$jobType' '$jobNameForMail' '$mailStatus' '$content'";
	`$cmd_mail`;
}

//-------------------------------------- T ------------------------------------------------
#****************************************************************************************************
# Subroutine Name			: traceLog
# Objective					: This function helps to add log
# Added By					: Sabin Cheruvattil [2016-05-10]
# Modified By				: Senthil Pandian
#****************************************************************************************************
function traceLog($data = "", $trace = array(), $access = "")
{
	GLOBAL $mode, $webDir, $username, $httpuser, $userDir, $machine;
	$trace_dir_name		= '.trace';

	if($mode === 'debug' || $data == '')
		return;

	try {
		if(!is_array($trace) || empty($trace)) 
			$trace = debug_backtrace();
		$user = $httpuser;
		if((ASUSTOR == $machine) and ($user == 'root')){
			$user = 'admin';
		}
		$date 		= date("Y/m/d H:i:s");
		$content 	= "[$date][".$user."][".basename($trace[0]['file'])."][Line:".$trace[0]['line']."] ".trim($data)."\n";
		$traceDir 	= $userDir . "/{$trace_dir_name}";
		
		if(!is_dir($userDir)) {
			mkdir($userDir,PERMISSIONVAL);
			@chmod($userDir, PERMISSIONVAL);
		}
		
		if(!is_dir($traceDir)) {
			mkdir($traceDir, PERMISSIONVAL);
			@chmod($traceDir,PERMISSIONVAL);
		}		
				
		$log_file =  $traceDir . '/' . LOG_FILE;

		if(file_exists($log_file)) {
			if(customFileSize($log_file) >= MAX_LOG_FILE_SIZE * 1024 * 1024) {
				//$log_file_back 		= 'traceLog.txt_' . date("D M d H:i:s Y");
				$log_file_back 		= 'traceLog.txt_' . trim(shell_exec('date +"%a %b %d %T %Y"'));
				$lock_back_pattern 	= '/traceLog.txt_*';				
				rename($log_file, dirname($log_file) . '/' . $log_file_back);
				
				# The following code only needs to run when the log is getting renamed
				# as there will be un necesssary checks for the number of log files whenever log method is called
				$logs = glob(dirname($log_file) . $lock_back_pattern);
				
				if(count($logs) > MAX_LOG_FILE_COUNT) {
					while(count($logs) > MAX_LOG_FILE_COUNT)
						unlink(array_shift($logs));
					}
					file_put_contents($log_file, "IDrive Username: " . $username . "\n");
				}
		}
		else
			file_put_contents($log_file, "IDrive Username: " . $username . "\n");
		
		file_put_contents($log_file, $content, FILE_APPEND);
		@chmod($log_file,PERMISSIONVAL);
	} catch(Exception $e) {}
}

//-------------------------------------- U ------------------------------------------------

#******************************************************************************************************************
# Subroutine Name         : updateLogFileName.
# Objective               : This subroutine renames backup log file and update new name to logpid.txt.
# Added By                : Pooja Havaldar
# Modified By			  : Avinash Kumar
#******************************************************************************************************************/
function updateLogFileName()
{
	GLOBAL $logOutputFilePath;
	GLOBAL $status;
	
	$currPath = `pwd`;
	$currPath = trim($currPath);
	$newName = "$currPath/$logOutputFilePath"."_".$status;
	$resCmd = "mv \"$logOutputFilePath\" \"$newName\"";
	$res = `$resCmd`;
	$logOutputFilePath = $newName;

	file_put_contents(LOGPIDFILE,$newName);
	chmod(LOGPIDFILE, PERMISSIONVAL);
}

#******************************************************************************************************************
# Subroutine Name         : updateProgressFile.
# Objective               : Update the progess file.
# Added By                : Avinash Kumar
# Modified By			  : Senthil Pandian
#******************************************************************************************************************/
function updateProgressFile($type, $fileName, $size, $curTransferedSize, $rateOfTransfer, $opStartTime)
{
	GLOBAL $totalSize;
	
	if("calculating" == $totalSize and file_exists(TOTAL_SIZE_PATH) and customFileSize(TOTAL_SIZE_PATH)>0)
		$totalSize = file_get_contents(TOTAL_SIZE_PATH);
	
	file_put_contents(PROGRESS_PATH,"$type\n$fileName\n$size\n$curTransferedSize\n$rateOfTransfer\n$totalSize\n$opStartTime :::::");
	@chmod(PROGRESS_PATH,PERMISSIONVAL);
}

#****************************************************************************************************
# Subroutine Name         : updateServerAddr.
# Objective               : Construction of get-server address evs command and execution.
#			    			Parse the output and update same in Account Setting File.
# Added By                : Vijay Vinoth.
#*****************************************************************************************************/
function updateServerAddr()
{
	GLOBAL $idevsutilBinaryPath,$hashEvsParameters,$userDir,$serverAddr;

	$getServerUtfFile = getOperationFile(GETSERVERADDRESS);

	$idevsutilCommandLine = $idevsutilBinaryPath.WHITESPACE.$hashEvsParameters["UTF8CMD"].ASSIGNMENTOP."\"$getServerUtfFile\"".WHITESPACE.ERRORREDIRECTION.LINEFEED;
	$commandOutput = `$idevsutilCommandLine`;

	unlink($getServerUtfFile);

    $serverAddr = '';
	$xmlArray = simplexml_load_string($commandOutput);
	$serverAddr = (string)$xmlArray['cmdUtilityServer'];
  
	$sreverAddrPath = "$userDir/".SERVER_ADDR_PATH;
	
	$fdWrite = fopen($sreverAddrPath, 'w+');
	if($fdWrite){
		fwrite($fdWrite,$serverAddr);
		fclose($fdWrite);
		@chmod($fdWrite, PERMISSIONVAL);
	}else{
		traceLog("Unable to open file $sreverAddrPath, Reason:".customErrorMsg());
	}
	
	return $serverAddr;
}
#******************************************************************************************************************
# Subroutine Name         : updateStatusFile.
# Objective               : Read file and made some changes and overwrite to that file.
# Added By                : Vijay Vinoth.
#******************************************************************************************************************/
function updateStatusFile($failedfiles_index)
{
	$status_file = file(STATUSFILE);
	if($status_file){
		$status_file[3] = "FILE_COUNT_INDEX = $failedfiles_index \n";
		file_put_contents(STATUSFILE, implode("", $status_file));
	    @chmod(STATUSFILE, PERMISSIONVAL);
	}else{
		traceLog("update Status file function failed. Reason : ".customErrorMsg());
		return false;
	}
	return true;
}

#******************************************************************************************************************
# Subroutine Name         : updateRetryCount.
# Objective               : This subroutine update retry count based on any success backup/sync.
# Added By                : Vijay Vinoth.
#******************************************************************************************************************/
function updateRetryCount()
{
	GLOBAL $retrycount, $prevFailedCount;
	$curFailedCount = 0;
	
	$curFailedCount = getParameterValueFromStatusFile("FAILED_COUNT_FILES_INDEX");
	if($prevFailedCount == 0 or $curFailedCount < $prevFailedCount)
		$retrycount = 0;
	else 
		$retrycount++;
	
	# assign the latest backuped and synced value to prev.
	$prevFailedCount = $curFailedCount;
}

//-------------------------------------- V ------------------------------------------------


//-------------------------------------- W ------------------------------------------------
#****************************************************************************************************
# Subroutine Name         : waitForProcess.
# Objective               : wait for the given process id and also scan error file for process if 
#							needFileScan is true.
# Added By                : Deepak Chaurasia
#****************************************************************************************************/
function waitForProcess($pid, $needFileScan)
{
	if( extension_loaded('pcntl') && function_exists('pcntl_waitpid') )
		pcntl_waitpid($pid,$status); 
	else 
		waitForEVS($pid, $needFileScan);
}

#****************************************************************************************************
# Subroutine Name         : writeBackupErrorMsgToStatusFile.
# Objective               : append errStr message to STATUS_FILE file.
# Added By                : Avinash Kumar
# Modified By			  : Senthil Pandian
#****************************************************************************************************/
function writeBackupErrorMsgToStatusFile($errStr = '')
{
	GLOBAL $statusFileHash;
	
	$Backupcount  = 0;
	$Synccount    = 0;
	$failedcount  = 0;
	$failed_index = 0;
	
	# read the restore, sync, error count and restore termination status from status file
	if(file_exists(STATUSFILE)){
		$Backupcount  = getParameterValueFromStatusFile("BACKUP_COUNT_FILES_INDEX");
		$Synccount    = getParameterValueFromStatusFile("SYNC_COUNT_FILES_INDEX");
		$failedcount  = getParameterValueFromStatusFile("FAILED_COUNT_FILES_INDEX");
		$failed_index = getParameterValueFromStatusFile("FILE_COUNT_INDEX");
	}
	
	try{
		$errStr = trim($errStr);
		$exit_flag  = "1-$errStr";
		$status     =	"BACKUP_COUNT_FILES_INDEX = $Backupcount\n";
		$status	   .=	"SYNC_COUNT_FILES_INDEX = $Synccount\n";
		$status	   .=	"FAILED_COUNT_FILES_INDEX = $failedcount\n";
		$status	   .=	"FILE_COUNT_INDEX = $failed_index\n";
		$status	   .=	"EXIT_FLAG_INDEX = $exit_flag ";	
		file_put_contents(STATUSFILE, $status);
		@chmod(STATUSFILE,PERMISSIONVAL);
		$statusFileHash=array();		
	}
	catch(Exception $e) {
		traceLog("Failed to open ".STATUSFILE.", Reason:".$e->getMessage());
		return;
	}
}

#****************************************************************************************************
# Subroutine Name         : writeOperationSummary
# Objective               : Writes the backup summary to the output file
# Added By                : Arnab Gupta.
# Modified By			  : Pooja Havaldar
#*****************************************************************************************************/
function writeOperationSummary($backupOpParam)
{	
	GLOBAL $filesConsideredCount;
	GLOBAL $totalFiles;
	GLOBAL $failedFiles;
	GLOBAL $failedFilesCount;
	GLOBAL $logOutputFilePath;
	GLOBAL $summaryMsg;
	GLOBAL $syncedFiles;
	GLOBAL $bacSync;
	GLOBAL $successFiles;
	GLOBAL $errStr;
	GLOBAL $mailSummaryMsg;
	
	$filesConsideredCount = $totalFiles;
	$failedFiles += $failedFilesCount;
	
	# open output.txt file to write restore summary.
	if(!($logOutputHandle = fopen($logOutputFilePath, "a"))){
		traceLog("Unable to open file $logOutputFilePath, Reason:".customErrorMsg());
		return;
	}
	
	if($failedFiles <= 0)
		$failedFiles = 0;
	else
		$summaryMsg .= appendErrorFileContents();
	
	trim($filesConsideredCount);
	
	# construct summary message.
	$summaryMsg .= LINEFEED.LINEFEED."Summary: ".LINEFEED;
	if($backupOpParam == BACKUP){
		$syncedFiles = $syncedFiles + $bacSync;
		$mailSummaryMsg =	"Files considered for backup: $filesConsideredCount ".LINEFEED.
							"Files backed up now: $successFiles ".LINEFEED.
							"Files already present in your account: $syncedFiles ".LINEFEED.
							"Files failed to backup:  $failedFiles ".LINEFEED;
		//$summaryMsg .= "$mailSummaryMsg ".LINEFEED."Backup End Time: ".WHITESPACE.date("D M d H:i:s Y").LINEFEED;
		$summaryMsg .= "$mailSummaryMsg ".LINEFEED."Backup End Time: ".trim(shell_exec('date +"%a %b %d %T %Y"')).LINEFEED;
		//$mailSummaryMsg .= "Backup End Time: ".WHITESPACE.date("D M d H:i:s Y").LINEFEED;
		$mailSummaryMsg .= "Backup End Time: ".WHITESPACE.trim(shell_exec('date +"%a %b %d %T %Y"')).LINEFEED;
	}
	else{
		$mailSummaryMsg =	"Files considered for restore: $filesConsideredCount ".LINEFEED.
							"Files restored now: $successFiles ".LINEFEED.
							"Files already present: $syncedFiles ".LINEFEED.
							"Files failed to restore:  $failedFiles ".LINEFEED;
		//$summaryMsg .= "$mailSummaryMsg ".LINEFEED."Restore End Time: ".WHITESPACE.date("D M d H:i:s Y").LINEFEED;
		$summaryMsg .= "$mailSummaryMsg ".LINEFEED."Restore End Time: ".WHITESPACE.trim(shell_exec('date +"%a %b %d %T %Y"')).LINEFEED;
		//$mailSummaryMsg .= "Restore End Time: ".WHITESPACE.date("D M d H:i:s Y").LINEFEED;
		$mailSummaryMsg .= "Restore End Time: ".WHITESPACE.trim(shell_exec('date +"%a %b %d %T %Y"')).LINEFEED;
	}
	
    if("" != $errStr){
		$mailSummaryMsg .= LINEFEED."$errStr ".LINEFEED;
		$summaryMsg .= LINEFEED."$errStr ".LINEFEED;
	}

	fwrite($logOutputHandle, $summaryMsg);
	fclose($logOutputHandle);
}
//-------------------------------------- X ------------------------------------------------


//-------------------------------------- Y ------------------------------------------------


//-------------------------------------- Z ------------------------------------------------

?>
