<?php
include_once 'path.php';

if(!isset($_SESSION['validUser']) || $_SESSION['validUser'] !== true)
	exit(header("Location:../index.php"));

if($_SESSION['validUser'] === true) {
	$proxyUser = isset($_SESSION['proxyUserName'])?$_SESSION['proxyUserName']:"";
	$proxyPwd  = isset($_SESSION['proxyPassword'])?$_SESSION['proxyPassword']:"";
	$proxyIP   = isset($_SESSION['ipAddress'])?$_SESSION['ipAddress']:"";
	$proxyPort = isset($_SESSION['port'])?$_SESSION['port']:"";

	$userName = $_SESSION['userName'];
	$password = $_SESSION['password']; 
	$encType = $_SESSION['encType'];
	
	$oldMask = umask(0);
	$accountSettingPath = Scheduler::$user_dir."ACCOUNT_SETTINGS_FILE";

	$resp = array();
	umask($oldMask);

	$file = fopen($accountSettingPath, "w+");
	if(!$file) {
		restartSession(); //Restart session
		$resp[] = false;
		$resp[] = "Failed to open account setting file : ".customErrorMsg()." <br> Account Settings File could not be created successfully";
		echo json_encode($resp);
		exit();
	} else {
		$serverAddr = getEVSServerAddr();	 //Getting EVS server address
		if("" == $proxyIP) {
			$proxyData = "";
		} else {
			$proxyData = (($proxyUser != "")?urlencode($proxyUser):"").":".(($proxyPwd != "")?urlencode($proxyPwd):"")."@".($proxyIP).":".($proxyPort);
		}

		fwrite($file, "userName = $userName \npassword = $password \nencType  = $encType \nserverAddr = $serverAddr\nPROXY = $proxyData\n");
		fclose($file);
		@chmod($accountSettingPath, $permissionVal);
	}
	unset($_SESSION['password']);
	
	/* Creating Default Backup/Restore Locations - Start */
	if(!file_exists($mpc))
		update_mpc();

	if(!file_exists($drlFile))
		createRestoreLocationFile();

	$localManualDir = Scheduler::$localbackup_dir."+ManualTask";
	$localStartPidfilePath = "$localManualDir/".START_PID;
	if(!isJobRunning($localStartPidfilePath)){
		@unlink("$localManualDir/".BACKUPSETFILEDISPLAY);
	}
	
	$backupManualDir = Scheduler::$backup_dir."+ManualTask";
	$backupStartPidfilePath = "$backupManualDir/".START_PID;
	if(!isJobRunning($backupStartPidfilePath)){
		@unlink("$backupManualDir/".BACKUPSETFILEDISPLAY);
	}
	
	$restoreManualDir = Scheduler::$restore_dir."+ManualTask";
	$restoreStartPidfilePath = "$restoreManualDir/".START_PID;
	if(!isJobRunning($restoreStartPidfilePath))
		@unlink("$restoreManualDir/".RESTORESETFILEDISPLAY);

	/* Creating Default Backup/Restore Locations - End */
	isRootLevelDisplayEnabled();
	if($_SESSION['displayRoot'])
		unset($_SESSION['sharedDirectoriesRaw']);
	
	killSizeFd(); //Killing the getSize process
	
	$dedup = false;
	$deviceIDExists = false;
	$deviceCount = 0;
	if(isset($_SESSION['dedup']) && $_SESSION['dedup']){
		getDedupDeviceList();
		$dedup = true;
		$deviceIDExists = deviceIDExists();
		if(isset($_SESSION['deviceList']))
			$deviceCount = count($_SESSION['deviceList']);			
	}
	
	$message = ACCOUNT_SET_SUCC;
	$_SESSION['configType'] = false;
	$resp[] = true;
	$resp[] = $message;
	$resp[] = false;
	$resp[] = $dedup;
	$resp[] = $deviceCount;
	$resp[] = $deviceIDExists;

	$_SESSION['validUser'] = true;
	echo json_encode($resp);
	exit();
} else {
	$resp[] = false;
	$resp[] = false;
	echo json_encode($resp);
	exit();
}
?>
